# coding: utf-8

"""
    Cloudbreak API

    Cloudbreak is a powerful left surf that breaks over a coral reef, a mile off southwest the island of Tavarua, Fiji. Cloudbreak is a cloud agnostic Hadoop as a Service API. Abstracts the provisioning and ease management and monitoring of on-demand clusters. SequenceIQ's Cloudbreak is a RESTful application development platform with the goal of helping developers to build solutions for deploying Hadoop YARN clusters in different environments. Once it is deployed in your favourite servlet container it exposes a REST API allowing to span up Hadoop clusters of arbitary sizes and cloud providers. Provisioning Hadoop has never been easier. Cloudbreak is built on the foundation of cloud providers API (Amazon AWS, Microsoft Azure, Google Cloud Platform, Openstack), Apache Ambari, Docker lightweight containers, Swarm and Consul. For further product documentation follow the link: <a href=\"http://hortonworks.com/apache/cloudbreak/\">http://hortonworks.com/apache/cloudbreak/</a>

    OpenAPI spec version: 2.7.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class AccountPreferencesResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'max_number_of_clusters': 'int',
        'max_number_of_nodes_per_cluster': 'int',
        'max_number_of_clusters_per_user': 'int',
        'allowed_instance_types': 'list[str]',
        'cluster_time_to_live': 'int',
        'user_time_to_live': 'int',
        'platforms': 'str',
        'smartsense_enabled': 'bool',
        'default_tags': 'dict(str, str)',
        'supported_external_databases': 'list[SupportedExternalDatabaseServiceEntryResponse]'
    }

    attribute_map = {
        'max_number_of_clusters': 'maxNumberOfClusters',
        'max_number_of_nodes_per_cluster': 'maxNumberOfNodesPerCluster',
        'max_number_of_clusters_per_user': 'maxNumberOfClustersPerUser',
        'allowed_instance_types': 'allowedInstanceTypes',
        'cluster_time_to_live': 'clusterTimeToLive',
        'user_time_to_live': 'userTimeToLive',
        'platforms': 'platforms',
        'smartsense_enabled': 'smartsenseEnabled',
        'default_tags': 'defaultTags',
        'supported_external_databases': 'supportedExternalDatabases'
    }

    def __init__(self, max_number_of_clusters=None, max_number_of_nodes_per_cluster=None, max_number_of_clusters_per_user=None, allowed_instance_types=None, cluster_time_to_live=None, user_time_to_live=None, platforms=None, smartsense_enabled=False, default_tags=None, supported_external_databases=None):
        """
        AccountPreferencesResponse - a model defined in Swagger
        """

        self._max_number_of_clusters = None
        self._max_number_of_nodes_per_cluster = None
        self._max_number_of_clusters_per_user = None
        self._allowed_instance_types = None
        self._cluster_time_to_live = None
        self._user_time_to_live = None
        self._platforms = None
        self._smartsense_enabled = None
        self._default_tags = None
        self._supported_external_databases = None

        if max_number_of_clusters is not None:
          self.max_number_of_clusters = max_number_of_clusters
        if max_number_of_nodes_per_cluster is not None:
          self.max_number_of_nodes_per_cluster = max_number_of_nodes_per_cluster
        if max_number_of_clusters_per_user is not None:
          self.max_number_of_clusters_per_user = max_number_of_clusters_per_user
        if allowed_instance_types is not None:
          self.allowed_instance_types = allowed_instance_types
        self.cluster_time_to_live = cluster_time_to_live
        self.user_time_to_live = user_time_to_live
        if platforms is not None:
          self.platforms = platforms
        if smartsense_enabled is not None:
          self.smartsense_enabled = smartsense_enabled
        if default_tags is not None:
          self.default_tags = default_tags
        if supported_external_databases is not None:
          self.supported_external_databases = supported_external_databases

    @property
    def max_number_of_clusters(self):
        """
        Gets the max_number_of_clusters of this AccountPreferencesResponse.
        max number of clusters in the account (0 when unlimited)

        :return: The max_number_of_clusters of this AccountPreferencesResponse.
        :rtype: int
        """
        return self._max_number_of_clusters

    @max_number_of_clusters.setter
    def max_number_of_clusters(self, max_number_of_clusters):
        """
        Sets the max_number_of_clusters of this AccountPreferencesResponse.
        max number of clusters in the account (0 when unlimited)

        :param max_number_of_clusters: The max_number_of_clusters of this AccountPreferencesResponse.
        :type: int
        """
        if max_number_of_clusters is not None and max_number_of_clusters < 0:
            raise ValueError("Invalid value for `max_number_of_clusters`, must be a value greater than or equal to `0`")

        self._max_number_of_clusters = max_number_of_clusters

    @property
    def max_number_of_nodes_per_cluster(self):
        """
        Gets the max_number_of_nodes_per_cluster of this AccountPreferencesResponse.
        max number of vms in a cluster of account (0 when unlimited)

        :return: The max_number_of_nodes_per_cluster of this AccountPreferencesResponse.
        :rtype: int
        """
        return self._max_number_of_nodes_per_cluster

    @max_number_of_nodes_per_cluster.setter
    def max_number_of_nodes_per_cluster(self, max_number_of_nodes_per_cluster):
        """
        Sets the max_number_of_nodes_per_cluster of this AccountPreferencesResponse.
        max number of vms in a cluster of account (0 when unlimited)

        :param max_number_of_nodes_per_cluster: The max_number_of_nodes_per_cluster of this AccountPreferencesResponse.
        :type: int
        """
        if max_number_of_nodes_per_cluster is not None and max_number_of_nodes_per_cluster < 0:
            raise ValueError("Invalid value for `max_number_of_nodes_per_cluster`, must be a value greater than or equal to `0`")

        self._max_number_of_nodes_per_cluster = max_number_of_nodes_per_cluster

    @property
    def max_number_of_clusters_per_user(self):
        """
        Gets the max_number_of_clusters_per_user of this AccountPreferencesResponse.
        max number of clusters for user within the account (0 when unlimited)

        :return: The max_number_of_clusters_per_user of this AccountPreferencesResponse.
        :rtype: int
        """
        return self._max_number_of_clusters_per_user

    @max_number_of_clusters_per_user.setter
    def max_number_of_clusters_per_user(self, max_number_of_clusters_per_user):
        """
        Sets the max_number_of_clusters_per_user of this AccountPreferencesResponse.
        max number of clusters for user within the account (0 when unlimited)

        :param max_number_of_clusters_per_user: The max_number_of_clusters_per_user of this AccountPreferencesResponse.
        :type: int
        """
        if max_number_of_clusters_per_user is not None and max_number_of_clusters_per_user < 0:
            raise ValueError("Invalid value for `max_number_of_clusters_per_user`, must be a value greater than or equal to `0`")

        self._max_number_of_clusters_per_user = max_number_of_clusters_per_user

    @property
    def allowed_instance_types(self):
        """
        Gets the allowed_instance_types of this AccountPreferencesResponse.
        allowed instance types in the account (empty list for no restriction)

        :return: The allowed_instance_types of this AccountPreferencesResponse.
        :rtype: list[str]
        """
        return self._allowed_instance_types

    @allowed_instance_types.setter
    def allowed_instance_types(self, allowed_instance_types):
        """
        Sets the allowed_instance_types of this AccountPreferencesResponse.
        allowed instance types in the account (empty list for no restriction)

        :param allowed_instance_types: The allowed_instance_types of this AccountPreferencesResponse.
        :type: list[str]
        """

        self._allowed_instance_types = allowed_instance_types

    @property
    def cluster_time_to_live(self):
        """
        Gets the cluster_time_to_live of this AccountPreferencesResponse.
        lifecycle of the cluster in hours (0 for immortal clusters)

        :return: The cluster_time_to_live of this AccountPreferencesResponse.
        :rtype: int
        """
        return self._cluster_time_to_live

    @cluster_time_to_live.setter
    def cluster_time_to_live(self, cluster_time_to_live):
        """
        Sets the cluster_time_to_live of this AccountPreferencesResponse.
        lifecycle of the cluster in hours (0 for immortal clusters)

        :param cluster_time_to_live: The cluster_time_to_live of this AccountPreferencesResponse.
        :type: int
        """
        if cluster_time_to_live is None:
            raise ValueError("Invalid value for `cluster_time_to_live`, must not be `None`")
        if cluster_time_to_live is not None and cluster_time_to_live < 0:
            raise ValueError("Invalid value for `cluster_time_to_live`, must be a value greater than or equal to `0`")

        self._cluster_time_to_live = cluster_time_to_live

    @property
    def user_time_to_live(self):
        """
        Gets the user_time_to_live of this AccountPreferencesResponse.
        lifecycle of the account and its clusters in hours (0 for immortal account)

        :return: The user_time_to_live of this AccountPreferencesResponse.
        :rtype: int
        """
        return self._user_time_to_live

    @user_time_to_live.setter
    def user_time_to_live(self, user_time_to_live):
        """
        Sets the user_time_to_live of this AccountPreferencesResponse.
        lifecycle of the account and its clusters in hours (0 for immortal account)

        :param user_time_to_live: The user_time_to_live of this AccountPreferencesResponse.
        :type: int
        """
        if user_time_to_live is None:
            raise ValueError("Invalid value for `user_time_to_live`, must not be `None`")
        if user_time_to_live is not None and user_time_to_live < 0:
            raise ValueError("Invalid value for `user_time_to_live`, must be a value greater than or equal to `0`")

        self._user_time_to_live = user_time_to_live

    @property
    def platforms(self):
        """
        Gets the platforms of this AccountPreferencesResponse.
        list of the cloudplatforms visible on the UI

        :return: The platforms of this AccountPreferencesResponse.
        :rtype: str
        """
        return self._platforms

    @platforms.setter
    def platforms(self, platforms):
        """
        Sets the platforms of this AccountPreferencesResponse.
        list of the cloudplatforms visible on the UI

        :param platforms: The platforms of this AccountPreferencesResponse.
        :type: str
        """

        self._platforms = platforms

    @property
    def smartsense_enabled(self):
        """
        Gets the smartsense_enabled of this AccountPreferencesResponse.
        smartsense enabled on the UI

        :return: The smartsense_enabled of this AccountPreferencesResponse.
        :rtype: bool
        """
        return self._smartsense_enabled

    @smartsense_enabled.setter
    def smartsense_enabled(self, smartsense_enabled):
        """
        Sets the smartsense_enabled of this AccountPreferencesResponse.
        smartsense enabled on the UI

        :param smartsense_enabled: The smartsense_enabled of this AccountPreferencesResponse.
        :type: bool
        """

        self._smartsense_enabled = smartsense_enabled

    @property
    def default_tags(self):
        """
        Gets the default_tags of this AccountPreferencesResponse.
        default tags for the resources created

        :return: The default_tags of this AccountPreferencesResponse.
        :rtype: dict(str, str)
        """
        return self._default_tags

    @default_tags.setter
    def default_tags(self, default_tags):
        """
        Sets the default_tags of this AccountPreferencesResponse.
        default tags for the resources created

        :param default_tags: The default_tags of this AccountPreferencesResponse.
        :type: dict(str, str)
        """

        self._default_tags = default_tags

    @property
    def supported_external_databases(self):
        """
        Gets the supported_external_databases of this AccountPreferencesResponse.

        :return: The supported_external_databases of this AccountPreferencesResponse.
        :rtype: list[SupportedExternalDatabaseServiceEntryResponse]
        """
        return self._supported_external_databases

    @supported_external_databases.setter
    def supported_external_databases(self, supported_external_databases):
        """
        Sets the supported_external_databases of this AccountPreferencesResponse.

        :param supported_external_databases: The supported_external_databases of this AccountPreferencesResponse.
        :type: list[SupportedExternalDatabaseServiceEntryResponse]
        """

        self._supported_external_databases = supported_external_databases

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, AccountPreferencesResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
