# coding: utf-8

"""
    Cloudbreak API

    Cloudbreak is a powerful left surf that breaks over a coral reef, a mile off southwest the island of Tavarua, Fiji. Cloudbreak is a cloud agnostic Hadoop as a Service API. Abstracts the provisioning and ease management and monitoring of on-demand clusters. SequenceIQ's Cloudbreak is a RESTful application development platform with the goal of helping developers to build solutions for deploying Hadoop YARN clusters in different environments. Once it is deployed in your favourite servlet container it exposes a REST API allowing to span up Hadoop clusters of arbitary sizes and cloud providers. Provisioning Hadoop has never been easier. Cloudbreak is built on the foundation of cloud providers API (Amazon AWS, Microsoft Azure, Google Cloud Platform, Openstack), Apache Ambari, Docker lightweight containers, Swarm and Consul. For further product documentation follow the link: <a href=\"http://hortonworks.com/apache/cloudbreak/\">http://hortonworks.com/apache/cloudbreak/</a>

    OpenAPI spec version: 2.7.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class BlueprintRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'ambari_blueprint': 'str',
        'description': 'str',
        'inputs': 'list[BlueprintParameter]',
        'tags': 'dict(str, object)',
        'name': 'str',
        'url': 'str',
        'properties': 'list[dict(str, dict(str, str))]'
    }

    attribute_map = {
        'ambari_blueprint': 'ambariBlueprint',
        'description': 'description',
        'inputs': 'inputs',
        'tags': 'tags',
        'name': 'name',
        'url': 'url',
        'properties': 'properties'
    }

    def __init__(self, ambari_blueprint=None, description=None, inputs=None, tags=None, name=None, url=None, properties=None):
        """
        BlueprintRequest - a model defined in Swagger
        """

        self._ambari_blueprint = None
        self._description = None
        self._inputs = None
        self._tags = None
        self._name = None
        self._url = None
        self._properties = None

        if ambari_blueprint is not None:
          self.ambari_blueprint = ambari_blueprint
        if description is not None:
          self.description = description
        if inputs is not None:
          self.inputs = inputs
        if tags is not None:
          self.tags = tags
        self.name = name
        if url is not None:
          self.url = url
        if properties is not None:
          self.properties = properties

    @property
    def ambari_blueprint(self):
        """
        Gets the ambari_blueprint of this BlueprintRequest.
        ambari blueprint JSON, set this or the url field

        :return: The ambari_blueprint of this BlueprintRequest.
        :rtype: str
        """
        return self._ambari_blueprint

    @ambari_blueprint.setter
    def ambari_blueprint(self, ambari_blueprint):
        """
        Sets the ambari_blueprint of this BlueprintRequest.
        ambari blueprint JSON, set this or the url field

        :param ambari_blueprint: The ambari_blueprint of this BlueprintRequest.
        :type: str
        """

        self._ambari_blueprint = ambari_blueprint

    @property
    def description(self):
        """
        Gets the description of this BlueprintRequest.
        description of the resource

        :return: The description of this BlueprintRequest.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this BlueprintRequest.
        description of the resource

        :param description: The description of this BlueprintRequest.
        :type: str
        """
        if description is not None and len(description) > 1000:
            raise ValueError("Invalid value for `description`, length must be less than or equal to `1000`")
        if description is not None and len(description) < 0:
            raise ValueError("Invalid value for `description`, length must be greater than or equal to `0`")

        self._description = description

    @property
    def inputs(self):
        """
        Gets the inputs of this BlueprintRequest.
        input parameters of the blueprint

        :return: The inputs of this BlueprintRequest.
        :rtype: list[BlueprintParameter]
        """
        return self._inputs

    @inputs.setter
    def inputs(self, inputs):
        """
        Sets the inputs of this BlueprintRequest.
        input parameters of the blueprint

        :param inputs: The inputs of this BlueprintRequest.
        :type: list[BlueprintParameter]
        """

        self._inputs = inputs

    @property
    def tags(self):
        """
        Gets the tags of this BlueprintRequest.
        user defined tags for blueprint

        :return: The tags of this BlueprintRequest.
        :rtype: dict(str, object)
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """
        Sets the tags of this BlueprintRequest.
        user defined tags for blueprint

        :param tags: The tags of this BlueprintRequest.
        :type: dict(str, object)
        """

        self._tags = tags

    @property
    def name(self):
        """
        Gets the name of this BlueprintRequest.
        name of the resource

        :return: The name of this BlueprintRequest.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this BlueprintRequest.
        name of the resource

        :param name: The name of this BlueprintRequest.
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")
        if name is not None and len(name) > 100:
            raise ValueError("Invalid value for `name`, length must be less than or equal to `100`")
        if name is not None and len(name) < 1:
            raise ValueError("Invalid value for `name`, length must be greater than or equal to `1`")

        self._name = name

    @property
    def url(self):
        """
        Gets the url of this BlueprintRequest.
        url source of an ambari blueprint, set this or the ambariBlueprint field

        :return: The url of this BlueprintRequest.
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """
        Sets the url of this BlueprintRequest.
        url source of an ambari blueprint, set this or the ambariBlueprint field

        :param url: The url of this BlueprintRequest.
        :type: str
        """

        self._url = url

    @property
    def properties(self):
        """
        Gets the properties of this BlueprintRequest.
        properties to extend the blueprint with

        :return: The properties of this BlueprintRequest.
        :rtype: list[dict(str, dict(str, str))]
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """
        Sets the properties of this BlueprintRequest.
        properties to extend the blueprint with

        :param properties: The properties of this BlueprintRequest.
        :type: list[dict(str, dict(str, str))]
        """

        self._properties = properties

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, BlueprintRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
