# coding: utf-8

"""
    Cloudbreak API

    Cloudbreak is a powerful left surf that breaks over a coral reef, a mile off southwest the island of Tavarua, Fiji. Cloudbreak is a cloud agnostic Hadoop as a Service API. Abstracts the provisioning and ease management and monitoring of on-demand clusters. SequenceIQ's Cloudbreak is a RESTful application development platform with the goal of helping developers to build solutions for deploying Hadoop YARN clusters in different environments. Once it is deployed in your favourite servlet container it exposes a REST API allowing to span up Hadoop clusters of arbitary sizes and cloud providers. Provisioning Hadoop has never been easier. Cloudbreak is built on the foundation of cloud providers API (Amazon AWS, Microsoft Azure, Google Cloud Platform, Openstack), Apache Ambari, Docker lightweight containers, Swarm and Consul. For further product documentation follow the link: <a href=\"http://hortonworks.com/apache/cloudbreak/\">http://hortonworks.com/apache/cloudbreak/</a>

    OpenAPI spec version: 2.7.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class CertificateResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'server_cert': 'list[str]',
        'client_key': 'list[str]',
        'client_cert': 'list[str]'
    }

    attribute_map = {
        'server_cert': 'serverCert',
        'client_key': 'clientKey',
        'client_cert': 'clientCert'
    }

    def __init__(self, server_cert=None, client_key=None, client_cert=None):
        """
        CertificateResponse - a model defined in Swagger
        """

        self._server_cert = None
        self._client_key = None
        self._client_cert = None

        if server_cert is not None:
          self.server_cert = server_cert
        if client_key is not None:
          self.client_key = client_key
        if client_cert is not None:
          self.client_cert = client_cert

    @property
    def server_cert(self):
        """
        Gets the server_cert of this CertificateResponse.
        server certificate used by the gateway

        :return: The server_cert of this CertificateResponse.
        :rtype: list[str]
        """
        return self._server_cert

    @server_cert.setter
    def server_cert(self, server_cert):
        """
        Sets the server_cert of this CertificateResponse.
        server certificate used by the gateway

        :param server_cert: The server_cert of this CertificateResponse.
        :type: list[str]
        """

        self._server_cert = server_cert

    @property
    def client_key(self):
        """
        Gets the client_key of this CertificateResponse.
        client key used by the gateway

        :return: The client_key of this CertificateResponse.
        :rtype: list[str]
        """
        return self._client_key

    @client_key.setter
    def client_key(self, client_key):
        """
        Sets the client_key of this CertificateResponse.
        client key used by the gateway

        :param client_key: The client_key of this CertificateResponse.
        :type: list[str]
        """

        self._client_key = client_key

    @property
    def client_cert(self):
        """
        Gets the client_cert of this CertificateResponse.
        client certificate used by the gateway

        :return: The client_cert of this CertificateResponse.
        :rtype: list[str]
        """
        return self._client_cert

    @client_cert.setter
    def client_cert(self, client_cert):
        """
        Sets the client_cert of this CertificateResponse.
        client certificate used by the gateway

        :param client_cert: The client_cert of this CertificateResponse.
        :type: list[str]
        """

        self._client_cert = client_cert

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, CertificateResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
