# coding: utf-8

"""
    Cloudbreak API

    Cloudbreak is a powerful left surf that breaks over a coral reef, a mile off southwest the island of Tavarua, Fiji. Cloudbreak is a cloud agnostic Hadoop as a Service API. Abstracts the provisioning and ease management and monitoring of on-demand clusters. SequenceIQ's Cloudbreak is a RESTful application development platform with the goal of helping developers to build solutions for deploying Hadoop YARN clusters in different environments. Once it is deployed in your favourite servlet container it exposes a REST API allowing to span up Hadoop clusters of arbitary sizes and cloud providers. Provisioning Hadoop has never been easier. Cloudbreak is built on the foundation of cloud providers API (Amazon AWS, Microsoft Azure, Google Cloud Platform, Openstack), Apache Ambari, Docker lightweight containers, Swarm and Consul. For further product documentation follow the link: <a href=\"http://hortonworks.com/apache/cloudbreak/\">http://hortonworks.com/apache/cloudbreak/</a>

    OpenAPI spec version: 2.7.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class CloudStorageSupportedResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'provider': 'str',
        'file_system_type': 'list[str]'
    }

    attribute_map = {
        'provider': 'provider',
        'file_system_type': 'fileSystemType'
    }

    def __init__(self, provider=None, file_system_type=None):
        """
        CloudStorageSupportedResponse - a model defined in Swagger
        """

        self._provider = None
        self._file_system_type = None

        if provider is not None:
          self.provider = provider
        if file_system_type is not None:
          self.file_system_type = file_system_type

    @property
    def provider(self):
        """
        Gets the provider of this CloudStorageSupportedResponse.

        :return: The provider of this CloudStorageSupportedResponse.
        :rtype: str
        """
        return self._provider

    @provider.setter
    def provider(self, provider):
        """
        Sets the provider of this CloudStorageSupportedResponse.

        :param provider: The provider of this CloudStorageSupportedResponse.
        :type: str
        """

        self._provider = provider

    @property
    def file_system_type(self):
        """
        Gets the file_system_type of this CloudStorageSupportedResponse.

        :return: The file_system_type of this CloudStorageSupportedResponse.
        :rtype: list[str]
        """
        return self._file_system_type

    @file_system_type.setter
    def file_system_type(self, file_system_type):
        """
        Sets the file_system_type of this CloudStorageSupportedResponse.

        :param file_system_type: The file_system_type of this CloudStorageSupportedResponse.
        :type: list[str]
        """

        self._file_system_type = file_system_type

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, CloudStorageSupportedResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
