# coding: utf-8

"""
    Cloudbreak API

    Cloudbreak is a powerful left surf that breaks over a coral reef, a mile off southwest the island of Tavarua, Fiji. Cloudbreak is a cloud agnostic Hadoop as a Service API. Abstracts the provisioning and ease management and monitoring of on-demand clusters. SequenceIQ's Cloudbreak is a RESTful application development platform with the goal of helping developers to build solutions for deploying Hadoop YARN clusters in different environments. Once it is deployed in your favourite servlet container it exposes a REST API allowing to span up Hadoop clusters of arbitary sizes and cloud providers. Provisioning Hadoop has never been easier. Cloudbreak is built on the foundation of cloud providers API (Amazon AWS, Microsoft Azure, Google Cloud Platform, Openstack), Apache Ambari, Docker lightweight containers, Swarm and Consul. For further product documentation follow the link: <a href=\"http://hortonworks.com/apache/cloudbreak/\">http://hortonworks.com/apache/cloudbreak/</a>

    OpenAPI spec version: 2.7.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ConfigsResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'fix_inputs': 'dict(str, object)',
        'datalake_inputs': 'dict(str, object)',
        'inputs': 'list[BlueprintInput]'
    }

    attribute_map = {
        'fix_inputs': 'fixInputs',
        'datalake_inputs': 'datalakeInputs',
        'inputs': 'inputs'
    }

    def __init__(self, fix_inputs=None, datalake_inputs=None, inputs=None):
        """
        ConfigsResponse - a model defined in Swagger
        """

        self._fix_inputs = None
        self._datalake_inputs = None
        self._inputs = None

        self.fix_inputs = fix_inputs
        self.datalake_inputs = datalake_inputs
        self.inputs = inputs

    @property
    def fix_inputs(self):
        """
        Gets the fix_inputs of this ConfigsResponse.
        fixinputs object

        :return: The fix_inputs of this ConfigsResponse.
        :rtype: dict(str, object)
        """
        return self._fix_inputs

    @fix_inputs.setter
    def fix_inputs(self, fix_inputs):
        """
        Sets the fix_inputs of this ConfigsResponse.
        fixinputs object

        :param fix_inputs: The fix_inputs of this ConfigsResponse.
        :type: dict(str, object)
        """
        if fix_inputs is None:
            raise ValueError("Invalid value for `fix_inputs`, must not be `None`")

        self._fix_inputs = fix_inputs

    @property
    def datalake_inputs(self):
        """
        Gets the datalake_inputs of this ConfigsResponse.
        datalakeinputs object

        :return: The datalake_inputs of this ConfigsResponse.
        :rtype: dict(str, object)
        """
        return self._datalake_inputs

    @datalake_inputs.setter
    def datalake_inputs(self, datalake_inputs):
        """
        Sets the datalake_inputs of this ConfigsResponse.
        datalakeinputs object

        :param datalake_inputs: The datalake_inputs of this ConfigsResponse.
        :type: dict(str, object)
        """
        if datalake_inputs is None:
            raise ValueError("Invalid value for `datalake_inputs`, must not be `None`")

        self._datalake_inputs = datalake_inputs

    @property
    def inputs(self):
        """
        Gets the inputs of this ConfigsResponse.
        response object

        :return: The inputs of this ConfigsResponse.
        :rtype: list[BlueprintInput]
        """
        return self._inputs

    @inputs.setter
    def inputs(self, inputs):
        """
        Sets the inputs of this ConfigsResponse.
        response object

        :param inputs: The inputs of this ConfigsResponse.
        :type: list[BlueprintInput]
        """
        if inputs is None:
            raise ValueError("Invalid value for `inputs`, must not be `None`")

        self._inputs = inputs

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ConfigsResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
