# coding: utf-8

"""
    Cloudbreak API

    Cloudbreak is a powerful left surf that breaks over a coral reef, a mile off southwest the island of Tavarua, Fiji. Cloudbreak is a cloud agnostic Hadoop as a Service API. Abstracts the provisioning and ease management and monitoring of on-demand clusters. SequenceIQ's Cloudbreak is a RESTful application development platform with the goal of helping developers to build solutions for deploying Hadoop YARN clusters in different environments. Once it is deployed in your favourite servlet container it exposes a REST API allowing to span up Hadoop clusters of arbitary sizes and cloud providers. Provisioning Hadoop has never been easier. Cloudbreak is built on the foundation of cloud providers API (Amazon AWS, Microsoft Azure, Google Cloud Platform, Openstack), Apache Ambari, Docker lightweight containers, Swarm and Consul. For further product documentation follow the link: <a href=\"http://hortonworks.com/apache/cloudbreak/\">http://hortonworks.com/apache/cloudbreak/</a>

    OpenAPI spec version: 2.7.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class Constraint(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'instance_group_name': 'str',
        'constraint_template_name': 'str',
        'host_count': 'int'
    }

    attribute_map = {
        'instance_group_name': 'instanceGroupName',
        'constraint_template_name': 'constraintTemplateName',
        'host_count': 'hostCount'
    }

    def __init__(self, instance_group_name=None, constraint_template_name=None, host_count=None):
        """
        Constraint - a model defined in Swagger
        """

        self._instance_group_name = None
        self._constraint_template_name = None
        self._host_count = None

        if instance_group_name is not None:
          self.instance_group_name = instance_group_name
        if constraint_template_name is not None:
          self.constraint_template_name = constraint_template_name
        self.host_count = host_count

    @property
    def instance_group_name(self):
        """
        Gets the instance_group_name of this Constraint.
        name of an instance group where the hostgroup will be deployed

        :return: The instance_group_name of this Constraint.
        :rtype: str
        """
        return self._instance_group_name

    @instance_group_name.setter
    def instance_group_name(self, instance_group_name):
        """
        Sets the instance_group_name of this Constraint.
        name of an instance group where the hostgroup will be deployed

        :param instance_group_name: The instance_group_name of this Constraint.
        :type: str
        """

        self._instance_group_name = instance_group_name

    @property
    def constraint_template_name(self):
        """
        Gets the constraint_template_name of this Constraint.
        name of a constraint template that defines the resource constraints for the hostgroup

        :return: The constraint_template_name of this Constraint.
        :rtype: str
        """
        return self._constraint_template_name

    @constraint_template_name.setter
    def constraint_template_name(self, constraint_template_name):
        """
        Sets the constraint_template_name of this Constraint.
        name of a constraint template that defines the resource constraints for the hostgroup

        :param constraint_template_name: The constraint_template_name of this Constraint.
        :type: str
        """

        self._constraint_template_name = constraint_template_name

    @property
    def host_count(self):
        """
        Gets the host_count of this Constraint.
        number of hosts in the hostgroup

        :return: The host_count of this Constraint.
        :rtype: int
        """
        return self._host_count

    @host_count.setter
    def host_count(self, host_count):
        """
        Sets the host_count of this Constraint.
        number of hosts in the hostgroup

        :param host_count: The host_count of this Constraint.
        :type: int
        """
        if host_count is None:
            raise ValueError("Invalid value for `host_count`, must not be `None`")

        self._host_count = host_count

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, Constraint):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
