# coding: utf-8

"""
    Cloudbreak API

    Cloudbreak is a powerful left surf that breaks over a coral reef, a mile off southwest the island of Tavarua, Fiji. Cloudbreak is a cloud agnostic Hadoop as a Service API. Abstracts the provisioning and ease management and monitoring of on-demand clusters. SequenceIQ's Cloudbreak is a RESTful application development platform with the goal of helping developers to build solutions for deploying Hadoop YARN clusters in different environments. Once it is deployed in your favourite servlet container it exposes a REST API allowing to span up Hadoop clusters of arbitary sizes and cloud providers. Provisioning Hadoop has never been easier. Cloudbreak is built on the foundation of cloud providers API (Amazon AWS, Microsoft Azure, Google Cloud Platform, Openstack), Apache Ambari, Docker lightweight containers, Swarm and Consul. For further product documentation follow the link: <a href=\"http://hortonworks.com/apache/cloudbreak/\">http://hortonworks.com/apache/cloudbreak/</a>

    OpenAPI spec version: 2.7.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class FailurePolicyRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'threshold': 'int',
        'adjustment_type': 'str'
    }

    attribute_map = {
        'threshold': 'threshold',
        'adjustment_type': 'adjustmentType'
    }

    def __init__(self, threshold=None, adjustment_type=None):
        """
        FailurePolicyRequest - a model defined in Swagger
        """

        self._threshold = None
        self._adjustment_type = None

        if threshold is not None:
          self.threshold = threshold
        self.adjustment_type = adjustment_type

    @property
    def threshold(self):
        """
        Gets the threshold of this FailurePolicyRequest.
        threshold of failure policy

        :return: The threshold of this FailurePolicyRequest.
        :rtype: int
        """
        return self._threshold

    @threshold.setter
    def threshold(self, threshold):
        """
        Sets the threshold of this FailurePolicyRequest.
        threshold of failure policy

        :param threshold: The threshold of this FailurePolicyRequest.
        :type: int
        """

        self._threshold = threshold

    @property
    def adjustment_type(self):
        """
        Gets the adjustment_type of this FailurePolicyRequest.
        type of  adjustment

        :return: The adjustment_type of this FailurePolicyRequest.
        :rtype: str
        """
        return self._adjustment_type

    @adjustment_type.setter
    def adjustment_type(self, adjustment_type):
        """
        Sets the adjustment_type of this FailurePolicyRequest.
        type of  adjustment

        :param adjustment_type: The adjustment_type of this FailurePolicyRequest.
        :type: str
        """
        if adjustment_type is None:
            raise ValueError("Invalid value for `adjustment_type`, must not be `None`")
        allowed_values = ["EXACT", "PERCENTAGE", "BEST_EFFORT"]
        if adjustment_type not in allowed_values:
            raise ValueError(
                "Invalid value for `adjustment_type` ({0}), must be one of {1}"
                .format(adjustment_type, allowed_values)
            )

        self._adjustment_type = adjustment_type

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, FailurePolicyRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
