# coding: utf-8

"""
    Cloudbreak API

    Cloudbreak is a powerful left surf that breaks over a coral reef, a mile off southwest the island of Tavarua, Fiji. Cloudbreak is a cloud agnostic Hadoop as a Service API. Abstracts the provisioning and ease management and monitoring of on-demand clusters. SequenceIQ's Cloudbreak is a RESTful application development platform with the goal of helping developers to build solutions for deploying Hadoop YARN clusters in different environments. Once it is deployed in your favourite servlet container it exposes a REST API allowing to span up Hadoop clusters of arbitary sizes and cloud providers. Provisioning Hadoop has never been easier. Cloudbreak is built on the foundation of cloud providers API (Amazon AWS, Microsoft Azure, Google Cloud Platform, Openstack), Apache Ambari, Docker lightweight containers, Swarm and Consul. For further product documentation follow the link: <a href=\"http://hortonworks.com/apache/cloudbreak/\">http://hortonworks.com/apache/cloudbreak/</a>

    OpenAPI spec version: 2.7.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class FlexSubscriptionRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'subscription_id': 'str',
        'smart_sense_subscription_id': 'int',
        'used_as_default': 'bool',
        'used_for_controller': 'bool'
    }

    attribute_map = {
        'name': 'name',
        'subscription_id': 'subscriptionId',
        'smart_sense_subscription_id': 'smartSenseSubscriptionId',
        'used_as_default': 'usedAsDefault',
        'used_for_controller': 'usedForController'
    }

    def __init__(self, name=None, subscription_id=None, smart_sense_subscription_id=None, used_as_default=False, used_for_controller=False):
        """
        FlexSubscriptionRequest - a model defined in Swagger
        """

        self._name = None
        self._subscription_id = None
        self._smart_sense_subscription_id = None
        self._used_as_default = None
        self._used_for_controller = None

        self.name = name
        if subscription_id is not None:
          self.subscription_id = subscription_id
        if smart_sense_subscription_id is not None:
          self.smart_sense_subscription_id = smart_sense_subscription_id
        if used_as_default is not None:
          self.used_as_default = used_as_default
        if used_for_controller is not None:
          self.used_for_controller = used_for_controller

    @property
    def name(self):
        """
        Gets the name of this FlexSubscriptionRequest.
        name of the resource

        :return: The name of this FlexSubscriptionRequest.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this FlexSubscriptionRequest.
        name of the resource

        :param name: The name of this FlexSubscriptionRequest.
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")

        self._name = name

    @property
    def subscription_id(self):
        """
        Gets the subscription_id of this FlexSubscriptionRequest.
        Identifier of Flex subscription.

        :return: The subscription_id of this FlexSubscriptionRequest.
        :rtype: str
        """
        return self._subscription_id

    @subscription_id.setter
    def subscription_id(self, subscription_id):
        """
        Sets the subscription_id of this FlexSubscriptionRequest.
        Identifier of Flex subscription.

        :param subscription_id: The subscription_id of this FlexSubscriptionRequest.
        :type: str
        """
        if subscription_id is not None and not re.search('^(FLEX-[0-9]{10}$)', subscription_id):
            raise ValueError("Invalid value for `subscription_id`, must be a follow pattern or equal to `/^(FLEX-[0-9]{10}$)/`")

        self._subscription_id = subscription_id

    @property
    def smart_sense_subscription_id(self):
        """
        Gets the smart_sense_subscription_id of this FlexSubscriptionRequest.
        Identifier of SmartSense subscription Cloudbreak domain object json representation.

        :return: The smart_sense_subscription_id of this FlexSubscriptionRequest.
        :rtype: int
        """
        return self._smart_sense_subscription_id

    @smart_sense_subscription_id.setter
    def smart_sense_subscription_id(self, smart_sense_subscription_id):
        """
        Sets the smart_sense_subscription_id of this FlexSubscriptionRequest.
        Identifier of SmartSense subscription Cloudbreak domain object json representation.

        :param smart_sense_subscription_id: The smart_sense_subscription_id of this FlexSubscriptionRequest.
        :type: int
        """

        self._smart_sense_subscription_id = smart_sense_subscription_id

    @property
    def used_as_default(self):
        """
        Gets the used_as_default of this FlexSubscriptionRequest.
        true if the flex subscription is the default one

        :return: The used_as_default of this FlexSubscriptionRequest.
        :rtype: bool
        """
        return self._used_as_default

    @used_as_default.setter
    def used_as_default(self, used_as_default):
        """
        Sets the used_as_default of this FlexSubscriptionRequest.
        true if the flex subscription is the default one

        :param used_as_default: The used_as_default of this FlexSubscriptionRequest.
        :type: bool
        """

        self._used_as_default = used_as_default

    @property
    def used_for_controller(self):
        """
        Gets the used_for_controller of this FlexSubscriptionRequest.
        true if the flex subscription was used for the controller

        :return: The used_for_controller of this FlexSubscriptionRequest.
        :rtype: bool
        """
        return self._used_for_controller

    @used_for_controller.setter
    def used_for_controller(self, used_for_controller):
        """
        Sets the used_for_controller of this FlexSubscriptionRequest.
        true if the flex subscription was used for the controller

        :param used_for_controller: The used_for_controller of this FlexSubscriptionRequest.
        :type: bool
        """

        self._used_for_controller = used_for_controller

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, FlexSubscriptionRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
