# coding: utf-8

"""
    Cloudbreak API

    Cloudbreak is a powerful left surf that breaks over a coral reef, a mile off southwest the island of Tavarua, Fiji. Cloudbreak is a cloud agnostic Hadoop as a Service API. Abstracts the provisioning and ease management and monitoring of on-demand clusters. SequenceIQ's Cloudbreak is a RESTful application development platform with the goal of helping developers to build solutions for deploying Hadoop YARN clusters in different environments. Once it is deployed in your favourite servlet container it exposes a REST API allowing to span up Hadoop clusters of arbitary sizes and cloud providers. Provisioning Hadoop has never been easier. Cloudbreak is built on the foundation of cloud providers API (Amazon AWS, Microsoft Azure, Google Cloud Platform, Openstack), Apache Ambari, Docker lightweight containers, Swarm and Consul. For further product documentation follow the link: <a href=\"http://hortonworks.com/apache/cloudbreak/\">http://hortonworks.com/apache/cloudbreak/</a>

    OpenAPI spec version: 2.7.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class OrchestratorResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'parameters': 'dict(str, object)',
        'api_endpoint': 'str',
        'type': 'str'
    }

    attribute_map = {
        'parameters': 'parameters',
        'api_endpoint': 'apiEndpoint',
        'type': 'type'
    }

    def __init__(self, parameters=None, api_endpoint=None, type=None):
        """
        OrchestratorResponse - a model defined in Swagger
        """

        self._parameters = None
        self._api_endpoint = None
        self._type = None

        if parameters is not None:
          self.parameters = parameters
        if api_endpoint is not None:
          self.api_endpoint = api_endpoint
        self.type = type

    @property
    def parameters(self):
        """
        Gets the parameters of this OrchestratorResponse.
        orchestrator specific parameters, like authentication details

        :return: The parameters of this OrchestratorResponse.
        :rtype: dict(str, object)
        """
        return self._parameters

    @parameters.setter
    def parameters(self, parameters):
        """
        Sets the parameters of this OrchestratorResponse.
        orchestrator specific parameters, like authentication details

        :param parameters: The parameters of this OrchestratorResponse.
        :type: dict(str, object)
        """

        self._parameters = parameters

    @property
    def api_endpoint(self):
        """
        Gets the api_endpoint of this OrchestratorResponse.
        endpoint for the container orchestration api

        :return: The api_endpoint of this OrchestratorResponse.
        :rtype: str
        """
        return self._api_endpoint

    @api_endpoint.setter
    def api_endpoint(self, api_endpoint):
        """
        Sets the api_endpoint of this OrchestratorResponse.
        endpoint for the container orchestration api

        :param api_endpoint: The api_endpoint of this OrchestratorResponse.
        :type: str
        """

        self._api_endpoint = api_endpoint

    @property
    def type(self):
        """
        Gets the type of this OrchestratorResponse.
        type of the orchestrator

        :return: The type of this OrchestratorResponse.
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """
        Sets the type of this OrchestratorResponse.
        type of the orchestrator

        :param type: The type of this OrchestratorResponse.
        :type: str
        """
        if type is None:
            raise ValueError("Invalid value for `type`, must not be `None`")

        self._type = type

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, OrchestratorResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
