# coding: utf-8

"""
    Cloudbreak API

    Cloudbreak is a powerful left surf that breaks over a coral reef, a mile off southwest the island of Tavarua, Fiji. Cloudbreak is a cloud agnostic Hadoop as a Service API. Abstracts the provisioning and ease management and monitoring of on-demand clusters. SequenceIQ's Cloudbreak is a RESTful application development platform with the goal of helping developers to build solutions for deploying Hadoop YARN clusters in different environments. Once it is deployed in your favourite servlet container it exposes a REST API allowing to span up Hadoop clusters of arbitary sizes and cloud providers. Provisioning Hadoop has never been easier. Cloudbreak is built on the foundation of cloud providers API (Amazon AWS, Microsoft Azure, Google Cloud Platform, Openstack), Apache Ambari, Docker lightweight containers, Swarm and Consul. For further product documentation follow the link: <a href=\"http://hortonworks.com/apache/cloudbreak/\">http://hortonworks.com/apache/cloudbreak/</a>

    OpenAPI spec version: 2.7.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class PlatformOrchestratorsJson(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'orchestrators': 'dict(str, list[str])',
        'defaults': 'dict(str, str)'
    }

    attribute_map = {
        'orchestrators': 'orchestrators',
        'defaults': 'defaults'
    }

    def __init__(self, orchestrators=None, defaults=None):
        """
        PlatformOrchestratorsJson - a model defined in Swagger
        """

        self._orchestrators = None
        self._defaults = None

        if orchestrators is not None:
          self.orchestrators = orchestrators
        if defaults is not None:
          self.defaults = defaults

    @property
    def orchestrators(self):
        """
        Gets the orchestrators of this PlatformOrchestratorsJson.
        orchestrators

        :return: The orchestrators of this PlatformOrchestratorsJson.
        :rtype: dict(str, list[str])
        """
        return self._orchestrators

    @orchestrators.setter
    def orchestrators(self, orchestrators):
        """
        Sets the orchestrators of this PlatformOrchestratorsJson.
        orchestrators

        :param orchestrators: The orchestrators of this PlatformOrchestratorsJson.
        :type: dict(str, list[str])
        """

        self._orchestrators = orchestrators

    @property
    def defaults(self):
        """
        Gets the defaults of this PlatformOrchestratorsJson.
        default orchestrators

        :return: The defaults of this PlatformOrchestratorsJson.
        :rtype: dict(str, str)
        """
        return self._defaults

    @defaults.setter
    def defaults(self, defaults):
        """
        Sets the defaults of this PlatformOrchestratorsJson.
        default orchestrators

        :param defaults: The defaults of this PlatformOrchestratorsJson.
        :type: dict(str, str)
        """

        self._defaults = defaults

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, PlatformOrchestratorsJson):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
