# coding: utf-8

"""
    Cloudbreak API

    Cloudbreak is a powerful left surf that breaks over a coral reef, a mile off southwest the island of Tavarua, Fiji. Cloudbreak is a cloud agnostic Hadoop as a Service API. Abstracts the provisioning and ease management and monitoring of on-demand clusters. SequenceIQ's Cloudbreak is a RESTful application development platform with the goal of helping developers to build solutions for deploying Hadoop YARN clusters in different environments. Once it is deployed in your favourite servlet container it exposes a REST API allowing to span up Hadoop clusters of arbitary sizes and cloud providers. Provisioning Hadoop has never been easier. Cloudbreak is built on the foundation of cloud providers API (Amazon AWS, Microsoft Azure, Google Cloud Platform, Openstack), Apache Ambari, Docker lightweight containers, Swarm and Consul. For further product documentation follow the link: <a href=\"http://hortonworks.com/apache/cloudbreak/\">http://hortonworks.com/apache/cloudbreak/</a>

    OpenAPI spec version: 2.7.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class PlatformSecurityGroupResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'group_name': 'str',
        'group_id': 'str',
        'properties': 'dict(str, object)'
    }

    attribute_map = {
        'group_name': 'groupName',
        'group_id': 'groupId',
        'properties': 'properties'
    }

    def __init__(self, group_name=None, group_id=None, properties=None):
        """
        PlatformSecurityGroupResponse - a model defined in Swagger
        """

        self._group_name = None
        self._group_id = None
        self._properties = None

        if group_name is not None:
          self.group_name = group_name
        if group_id is not None:
          self.group_id = group_id
        if properties is not None:
          self.properties = properties

    @property
    def group_name(self):
        """
        Gets the group_name of this PlatformSecurityGroupResponse.

        :return: The group_name of this PlatformSecurityGroupResponse.
        :rtype: str
        """
        return self._group_name

    @group_name.setter
    def group_name(self, group_name):
        """
        Sets the group_name of this PlatformSecurityGroupResponse.

        :param group_name: The group_name of this PlatformSecurityGroupResponse.
        :type: str
        """

        self._group_name = group_name

    @property
    def group_id(self):
        """
        Gets the group_id of this PlatformSecurityGroupResponse.

        :return: The group_id of this PlatformSecurityGroupResponse.
        :rtype: str
        """
        return self._group_id

    @group_id.setter
    def group_id(self, group_id):
        """
        Sets the group_id of this PlatformSecurityGroupResponse.

        :param group_id: The group_id of this PlatformSecurityGroupResponse.
        :type: str
        """

        self._group_id = group_id

    @property
    def properties(self):
        """
        Gets the properties of this PlatformSecurityGroupResponse.

        :return: The properties of this PlatformSecurityGroupResponse.
        :rtype: dict(str, object)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """
        Sets the properties of this PlatformSecurityGroupResponse.

        :param properties: The properties of this PlatformSecurityGroupResponse.
        :type: dict(str, object)
        """

        self._properties = properties

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, PlatformSecurityGroupResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
