# coding: utf-8

"""
    Cloudbreak API

    Cloudbreak is a powerful left surf that breaks over a coral reef, a mile off southwest the island of Tavarua, Fiji. Cloudbreak is a cloud agnostic Hadoop as a Service API. Abstracts the provisioning and ease management and monitoring of on-demand clusters. SequenceIQ's Cloudbreak is a RESTful application development platform with the goal of helping developers to build solutions for deploying Hadoop YARN clusters in different environments. Once it is deployed in your favourite servlet container it exposes a REST API allowing to span up Hadoop clusters of arbitary sizes and cloud providers. Provisioning Hadoop has never been easier. Cloudbreak is built on the foundation of cloud providers API (Amazon AWS, Microsoft Azure, Google Cloud Platform, Openstack), Apache Ambari, Docker lightweight containers, Swarm and Consul. For further product documentation follow the link: <a href=\"http://hortonworks.com/apache/cloudbreak/\">http://hortonworks.com/apache/cloudbreak/</a>

    OpenAPI spec version: 2.7.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class RDSBuildRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'rds_config_request': 'RdsConfig',
        'cluster_name': 'str'
    }

    attribute_map = {
        'rds_config_request': 'rdsConfigRequest',
        'cluster_name': 'clusterName'
    }

    def __init__(self, rds_config_request=None, cluster_name=None):
        """
        RDSBuildRequest - a model defined in Swagger
        """

        self._rds_config_request = None
        self._cluster_name = None

        self.rds_config_request = rds_config_request
        self.cluster_name = cluster_name

    @property
    def rds_config_request(self):
        """
        Gets the rds_config_request of this RDSBuildRequest.
        rds config request

        :return: The rds_config_request of this RDSBuildRequest.
        :rtype: RdsConfig
        """
        return self._rds_config_request

    @rds_config_request.setter
    def rds_config_request(self, rds_config_request):
        """
        Sets the rds_config_request of this RDSBuildRequest.
        rds config request

        :param rds_config_request: The rds_config_request of this RDSBuildRequest.
        :type: RdsConfig
        """
        if rds_config_request is None:
            raise ValueError("Invalid value for `rds_config_request`, must not be `None`")

        self._rds_config_request = rds_config_request

    @property
    def cluster_name(self):
        """
        Gets the cluster_name of this RDSBuildRequest.
        requested cluster name

        :return: The cluster_name of this RDSBuildRequest.
        :rtype: str
        """
        return self._cluster_name

    @cluster_name.setter
    def cluster_name(self, cluster_name):
        """
        Sets the cluster_name of this RDSBuildRequest.
        requested cluster name

        :param cluster_name: The cluster_name of this RDSBuildRequest.
        :type: str
        """
        if cluster_name is None:
            raise ValueError("Invalid value for `cluster_name`, must not be `None`")

        self._cluster_name = cluster_name

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, RDSBuildRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
