# coding: utf-8

"""
    Cloudbreak API

    Cloudbreak is a powerful left surf that breaks over a coral reef, a mile off southwest the island of Tavarua, Fiji. Cloudbreak is a cloud agnostic Hadoop as a Service API. Abstracts the provisioning and ease management and monitoring of on-demand clusters. SequenceIQ's Cloudbreak is a RESTful application development platform with the goal of helping developers to build solutions for deploying Hadoop YARN clusters in different environments. Once it is deployed in your favourite servlet container it exposes a REST API allowing to span up Hadoop clusters of arbitary sizes and cloud providers. Provisioning Hadoop has never been easier. Cloudbreak is built on the foundation of cloud providers API (Amazon AWS, Microsoft Azure, Google Cloud Platform, Openstack), Apache Ambari, Docker lightweight containers, Swarm and Consul. For further product documentation follow the link: <a href=\"http://hortonworks.com/apache/cloudbreak/\">http://hortonworks.com/apache/cloudbreak/</a>

    OpenAPI spec version: 2.7.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class RepoConfigValidationResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'ambari_base_url': 'bool',
        'ambari_gpg_key_url': 'bool',
        'stack_base_url': 'bool',
        'utils_base_url': 'bool',
        'version_definition_file_url': 'bool',
        'mpack_url': 'bool'
    }

    attribute_map = {
        'ambari_base_url': 'ambariBaseUrl',
        'ambari_gpg_key_url': 'ambariGpgKeyUrl',
        'stack_base_url': 'stackBaseURL',
        'utils_base_url': 'utilsBaseURL',
        'version_definition_file_url': 'versionDefinitionFileUrl',
        'mpack_url': 'mpackUrl'
    }

    def __init__(self, ambari_base_url=False, ambari_gpg_key_url=False, stack_base_url=False, utils_base_url=False, version_definition_file_url=False, mpack_url=False):
        """
        RepoConfigValidationResponse - a model defined in Swagger
        """

        self._ambari_base_url = None
        self._ambari_gpg_key_url = None
        self._stack_base_url = None
        self._utils_base_url = None
        self._version_definition_file_url = None
        self._mpack_url = None

        if ambari_base_url is not None:
          self.ambari_base_url = ambari_base_url
        if ambari_gpg_key_url is not None:
          self.ambari_gpg_key_url = ambari_gpg_key_url
        if stack_base_url is not None:
          self.stack_base_url = stack_base_url
        if utils_base_url is not None:
          self.utils_base_url = utils_base_url
        if version_definition_file_url is not None:
          self.version_definition_file_url = version_definition_file_url
        if mpack_url is not None:
          self.mpack_url = mpack_url

    @property
    def ambari_base_url(self):
        """
        Gets the ambari_base_url of this RepoConfigValidationResponse.
        Indicates the request's value with the same key is valid and reachable by Cloudbreak or not

        :return: The ambari_base_url of this RepoConfigValidationResponse.
        :rtype: bool
        """
        return self._ambari_base_url

    @ambari_base_url.setter
    def ambari_base_url(self, ambari_base_url):
        """
        Sets the ambari_base_url of this RepoConfigValidationResponse.
        Indicates the request's value with the same key is valid and reachable by Cloudbreak or not

        :param ambari_base_url: The ambari_base_url of this RepoConfigValidationResponse.
        :type: bool
        """

        self._ambari_base_url = ambari_base_url

    @property
    def ambari_gpg_key_url(self):
        """
        Gets the ambari_gpg_key_url of this RepoConfigValidationResponse.
        Indicates the request's value with the same key is valid and reachable by Cloudbreak or not

        :return: The ambari_gpg_key_url of this RepoConfigValidationResponse.
        :rtype: bool
        """
        return self._ambari_gpg_key_url

    @ambari_gpg_key_url.setter
    def ambari_gpg_key_url(self, ambari_gpg_key_url):
        """
        Sets the ambari_gpg_key_url of this RepoConfigValidationResponse.
        Indicates the request's value with the same key is valid and reachable by Cloudbreak or not

        :param ambari_gpg_key_url: The ambari_gpg_key_url of this RepoConfigValidationResponse.
        :type: bool
        """

        self._ambari_gpg_key_url = ambari_gpg_key_url

    @property
    def stack_base_url(self):
        """
        Gets the stack_base_url of this RepoConfigValidationResponse.
        Indicates the request's value with the same key is valid and reachable by Cloudbreak or not

        :return: The stack_base_url of this RepoConfigValidationResponse.
        :rtype: bool
        """
        return self._stack_base_url

    @stack_base_url.setter
    def stack_base_url(self, stack_base_url):
        """
        Sets the stack_base_url of this RepoConfigValidationResponse.
        Indicates the request's value with the same key is valid and reachable by Cloudbreak or not

        :param stack_base_url: The stack_base_url of this RepoConfigValidationResponse.
        :type: bool
        """

        self._stack_base_url = stack_base_url

    @property
    def utils_base_url(self):
        """
        Gets the utils_base_url of this RepoConfigValidationResponse.
        Indicates the request's value with the same key is valid and reachable by Cloudbreak or not

        :return: The utils_base_url of this RepoConfigValidationResponse.
        :rtype: bool
        """
        return self._utils_base_url

    @utils_base_url.setter
    def utils_base_url(self, utils_base_url):
        """
        Sets the utils_base_url of this RepoConfigValidationResponse.
        Indicates the request's value with the same key is valid and reachable by Cloudbreak or not

        :param utils_base_url: The utils_base_url of this RepoConfigValidationResponse.
        :type: bool
        """

        self._utils_base_url = utils_base_url

    @property
    def version_definition_file_url(self):
        """
        Gets the version_definition_file_url of this RepoConfigValidationResponse.
        Indicates the request's value with the same key is valid and reachable by Cloudbreak or not

        :return: The version_definition_file_url of this RepoConfigValidationResponse.
        :rtype: bool
        """
        return self._version_definition_file_url

    @version_definition_file_url.setter
    def version_definition_file_url(self, version_definition_file_url):
        """
        Sets the version_definition_file_url of this RepoConfigValidationResponse.
        Indicates the request's value with the same key is valid and reachable by Cloudbreak or not

        :param version_definition_file_url: The version_definition_file_url of this RepoConfigValidationResponse.
        :type: bool
        """

        self._version_definition_file_url = version_definition_file_url

    @property
    def mpack_url(self):
        """
        Gets the mpack_url of this RepoConfigValidationResponse.
        Indicates the request's value with the same key is valid and reachable by Cloudbreak or not

        :return: The mpack_url of this RepoConfigValidationResponse.
        :rtype: bool
        """
        return self._mpack_url

    @mpack_url.setter
    def mpack_url(self, mpack_url):
        """
        Sets the mpack_url of this RepoConfigValidationResponse.
        Indicates the request's value with the same key is valid and reachable by Cloudbreak or not

        :param mpack_url: The mpack_url of this RepoConfigValidationResponse.
        :type: bool
        """

        self._mpack_url = mpack_url

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, RepoConfigValidationResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
