# coding: utf-8

"""
    Cloudbreak API

    Cloudbreak is a powerful left surf that breaks over a coral reef, a mile off southwest the island of Tavarua, Fiji. Cloudbreak is a cloud agnostic Hadoop as a Service API. Abstracts the provisioning and ease management and monitoring of on-demand clusters. SequenceIQ's Cloudbreak is a RESTful application development platform with the goal of helping developers to build solutions for deploying Hadoop YARN clusters in different environments. Once it is deployed in your favourite servlet container it exposes a REST API allowing to span up Hadoop clusters of arbitary sizes and cloud providers. Provisioning Hadoop has never been easier. Cloudbreak is built on the foundation of cloud providers API (Amazon AWS, Microsoft Azure, Google Cloud Platform, Openstack), Apache Ambari, Docker lightweight containers, Swarm and Consul. For further product documentation follow the link: <a href=\"http://hortonworks.com/apache/cloudbreak/\">http://hortonworks.com/apache/cloudbreak/</a>

    OpenAPI spec version: 2.7.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class SecurityGroupRequest(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'description': 'str',
        'security_group_id': 'str',
        'cloud_platform': 'str',
        'name': 'str',
        'security_rules': 'list[SecurityRuleRequest]'
    }

    attribute_map = {
        'description': 'description',
        'security_group_id': 'securityGroupId',
        'cloud_platform': 'cloudPlatform',
        'name': 'name',
        'security_rules': 'securityRules'
    }

    def __init__(self, description=None, security_group_id=None, cloud_platform=None, name=None, security_rules=None):
        """
        SecurityGroupRequest - a model defined in Swagger
        """

        self._description = None
        self._security_group_id = None
        self._cloud_platform = None
        self._name = None
        self._security_rules = None

        if description is not None:
          self.description = description
        if security_group_id is not None:
          self.security_group_id = security_group_id
        self.cloud_platform = cloud_platform
        self.name = name
        if security_rules is not None:
          self.security_rules = security_rules

    @property
    def description(self):
        """
        Gets the description of this SecurityGroupRequest.
        description of the resource

        :return: The description of this SecurityGroupRequest.
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """
        Sets the description of this SecurityGroupRequest.
        description of the resource

        :param description: The description of this SecurityGroupRequest.
        :type: str
        """
        if description is not None and len(description) > 1000:
            raise ValueError("Invalid value for `description`, length must be less than or equal to `1000`")
        if description is not None and len(description) < 0:
            raise ValueError("Invalid value for `description`, length must be greater than or equal to `0`")

        self._description = description

    @property
    def security_group_id(self):
        """
        Gets the security_group_id of this SecurityGroupRequest.
        Exisiting security group id

        :return: The security_group_id of this SecurityGroupRequest.
        :rtype: str
        """
        return self._security_group_id

    @security_group_id.setter
    def security_group_id(self, security_group_id):
        """
        Sets the security_group_id of this SecurityGroupRequest.
        Exisiting security group id

        :param security_group_id: The security_group_id of this SecurityGroupRequest.
        :type: str
        """

        self._security_group_id = security_group_id

    @property
    def cloud_platform(self):
        """
        Gets the cloud_platform of this SecurityGroupRequest.
        type of cloud provider

        :return: The cloud_platform of this SecurityGroupRequest.
        :rtype: str
        """
        return self._cloud_platform

    @cloud_platform.setter
    def cloud_platform(self, cloud_platform):
        """
        Sets the cloud_platform of this SecurityGroupRequest.
        type of cloud provider

        :param cloud_platform: The cloud_platform of this SecurityGroupRequest.
        :type: str
        """
        if cloud_platform is None:
            raise ValueError("Invalid value for `cloud_platform`, must not be `None`")

        self._cloud_platform = cloud_platform

    @property
    def name(self):
        """
        Gets the name of this SecurityGroupRequest.
        name of the resource

        :return: The name of this SecurityGroupRequest.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this SecurityGroupRequest.
        name of the resource

        :param name: The name of this SecurityGroupRequest.
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")
        if name is not None and not re.search('(^[a-z][-a-z0-9]*[a-z0-9]$)', name):
            raise ValueError("Invalid value for `name`, must be a follow pattern or equal to `/(^[a-z][-a-z0-9]*[a-z0-9]$)/`")

        self._name = name

    @property
    def security_rules(self):
        """
        Gets the security_rules of this SecurityGroupRequest.
        list of security rules that relates to the security group

        :return: The security_rules of this SecurityGroupRequest.
        :rtype: list[SecurityRuleRequest]
        """
        return self._security_rules

    @security_rules.setter
    def security_rules(self, security_rules):
        """
        Sets the security_rules of this SecurityGroupRequest.
        list of security rules that relates to the security group

        :param security_rules: The security_rules of this SecurityGroupRequest.
        :type: list[SecurityRuleRequest]
        """

        self._security_rules = security_rules

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, SecurityGroupRequest):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
