# coding: utf-8

"""
    Cloudbreak API

    Cloudbreak is a powerful left surf that breaks over a coral reef, a mile off southwest the island of Tavarua, Fiji. Cloudbreak is a cloud agnostic Hadoop as a Service API. Abstracts the provisioning and ease management and monitoring of on-demand clusters. SequenceIQ's Cloudbreak is a RESTful application development platform with the goal of helping developers to build solutions for deploying Hadoop YARN clusters in different environments. Once it is deployed in your favourite servlet container it exposes a REST API allowing to span up Hadoop clusters of arbitary sizes and cloud providers. Provisioning Hadoop has never been easier. Cloudbreak is built on the foundation of cloud providers API (Amazon AWS, Microsoft Azure, Google Cloud Platform, Openstack), Apache Ambari, Docker lightweight containers, Swarm and Consul. For further product documentation follow the link: <a href=\"http://hortonworks.com/apache/cloudbreak/\">http://hortonworks.com/apache/cloudbreak/</a>

    OpenAPI spec version: 2.7.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class StackAuthenticationResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'public_key': 'str',
        'public_key_id': 'str',
        'login_user_name': 'str'
    }

    attribute_map = {
        'public_key': 'publicKey',
        'public_key_id': 'publicKeyId',
        'login_user_name': 'loginUserName'
    }

    def __init__(self, public_key=None, public_key_id=None, login_user_name=None):
        """
        StackAuthenticationResponse - a model defined in Swagger
        """

        self._public_key = None
        self._public_key_id = None
        self._login_user_name = None

        if public_key is not None:
          self.public_key = public_key
        if public_key_id is not None:
          self.public_key_id = public_key_id
        if login_user_name is not None:
          self.login_user_name = login_user_name

    @property
    def public_key(self):
        """
        Gets the public_key of this StackAuthenticationResponse.
        public key for accessing instances

        :return: The public_key of this StackAuthenticationResponse.
        :rtype: str
        """
        return self._public_key

    @public_key.setter
    def public_key(self, public_key):
        """
        Sets the public_key of this StackAuthenticationResponse.
        public key for accessing instances

        :param public_key: The public_key of this StackAuthenticationResponse.
        :type: str
        """

        self._public_key = public_key

    @property
    def public_key_id(self):
        """
        Gets the public_key_id of this StackAuthenticationResponse.
        public key id for accessing instances

        :return: The public_key_id of this StackAuthenticationResponse.
        :rtype: str
        """
        return self._public_key_id

    @public_key_id.setter
    def public_key_id(self, public_key_id):
        """
        Sets the public_key_id of this StackAuthenticationResponse.
        public key id for accessing instances

        :param public_key_id: The public_key_id of this StackAuthenticationResponse.
        :type: str
        """

        self._public_key_id = public_key_id

    @property
    def login_user_name(self):
        """
        Gets the login_user_name of this StackAuthenticationResponse.
        authentication name for machines

        :return: The login_user_name of this StackAuthenticationResponse.
        :rtype: str
        """
        return self._login_user_name

    @login_user_name.setter
    def login_user_name(self, login_user_name):
        """
        Sets the login_user_name of this StackAuthenticationResponse.
        authentication name for machines

        :param login_user_name: The login_user_name of this StackAuthenticationResponse.
        :type: str
        """

        self._login_user_name = login_user_name

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, StackAuthenticationResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
