# coding: utf-8

"""
    Cloudbreak API

    Cloudbreak is a powerful left surf that breaks over a coral reef, a mile off southwest the island of Tavarua, Fiji. Cloudbreak is a cloud agnostic Hadoop as a Service API. Abstracts the provisioning and ease management and monitoring of on-demand clusters. SequenceIQ's Cloudbreak is a RESTful application development platform with the goal of helping developers to build solutions for deploying Hadoop YARN clusters in different environments. Once it is deployed in your favourite servlet container it exposes a REST API allowing to span up Hadoop clusters of arbitary sizes and cloud providers. Provisioning Hadoop has never been easier. Cloudbreak is built on the foundation of cloud providers API (Amazon AWS, Microsoft Azure, Google Cloud Platform, Openstack), Apache Ambari, Docker lightweight containers, Swarm and Consul. For further product documentation follow the link: <a href=\"http://hortonworks.com/apache/cloudbreak/\">http://hortonworks.com/apache/cloudbreak/</a>

    OpenAPI spec version: 2.7.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class UpdateStack(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'status': 'str',
        'with_cluster_event': 'bool',
        'instance_group_adjustment': 'InstanceGroupAdjustment'
    }

    attribute_map = {
        'status': 'status',
        'with_cluster_event': 'withClusterEvent',
        'instance_group_adjustment': 'instanceGroupAdjustment'
    }

    def __init__(self, status=None, with_cluster_event=False, instance_group_adjustment=None):
        """
        UpdateStack - a model defined in Swagger
        """

        self._status = None
        self._with_cluster_event = None
        self._instance_group_adjustment = None

        if status is not None:
          self.status = status
        if with_cluster_event is not None:
          self.with_cluster_event = with_cluster_event
        if instance_group_adjustment is not None:
          self.instance_group_adjustment = instance_group_adjustment

    @property
    def status(self):
        """
        Gets the status of this UpdateStack.
        status of the scale request

        :return: The status of this UpdateStack.
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """
        Sets the status of this UpdateStack.
        status of the scale request

        :param status: The status of this UpdateStack.
        :type: str
        """
        allowed_values = ["SYNC", "FULL_SYNC", "REPAIR_FAILED_NODES", "STOPPED", "STARTED"]
        if status not in allowed_values:
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def with_cluster_event(self):
        """
        Gets the with_cluster_event of this UpdateStack.
        on stack update, update cluster too

        :return: The with_cluster_event of this UpdateStack.
        :rtype: bool
        """
        return self._with_cluster_event

    @with_cluster_event.setter
    def with_cluster_event(self, with_cluster_event):
        """
        Sets the with_cluster_event of this UpdateStack.
        on stack update, update cluster too

        :param with_cluster_event: The with_cluster_event of this UpdateStack.
        :type: bool
        """

        self._with_cluster_event = with_cluster_event

    @property
    def instance_group_adjustment(self):
        """
        Gets the instance_group_adjustment of this UpdateStack.
        instance group adjustment

        :return: The instance_group_adjustment of this UpdateStack.
        :rtype: InstanceGroupAdjustment
        """
        return self._instance_group_adjustment

    @instance_group_adjustment.setter
    def instance_group_adjustment(self, instance_group_adjustment):
        """
        Sets the instance_group_adjustment of this UpdateStack.
        instance group adjustment

        :param instance_group_adjustment: The instance_group_adjustment of this UpdateStack.
        :type: InstanceGroupAdjustment
        """

        self._instance_group_adjustment = instance_group_adjustment

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, UpdateStack):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
