# coding: utf-8

"""
    Cloudbreak API

    Cloudbreak is a powerful left surf that breaks over a coral reef, a mile off southwest the island of Tavarua, Fiji. Cloudbreak is a cloud agnostic Hadoop as a Service API. Abstracts the provisioning and ease management and monitoring of on-demand clusters. SequenceIQ's Cloudbreak is a RESTful application development platform with the goal of helping developers to build solutions for deploying Hadoop YARN clusters in different environments. Once it is deployed in your favourite servlet container it exposes a REST API allowing to span up Hadoop clusters of arbitary sizes and cloud providers. Provisioning Hadoop has never been easier. Cloudbreak is built on the foundation of cloud providers API (Amazon AWS, Microsoft Azure, Google Cloud Platform, Openstack), Apache Ambari, Docker lightweight containers, Swarm and Consul. For further product documentation follow the link: <a href=\"http://hortonworks.com/apache/cloudbreak/\">http://hortonworks.com/apache/cloudbreak/</a>

    OpenAPI spec version: 2.7.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class VirtualMachinesResponse(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'virtual_machines': 'list[VmTypeJson]',
        'default_virtual_machine': 'VmTypeJson'
    }

    attribute_map = {
        'virtual_machines': 'virtualMachines',
        'default_virtual_machine': 'defaultVirtualMachine'
    }

    def __init__(self, virtual_machines=None, default_virtual_machine=None):
        """
        VirtualMachinesResponse - a model defined in Swagger
        """

        self._virtual_machines = None
        self._default_virtual_machine = None

        if virtual_machines is not None:
          self.virtual_machines = virtual_machines
        if default_virtual_machine is not None:
          self.default_virtual_machine = default_virtual_machine

    @property
    def virtual_machines(self):
        """
        Gets the virtual_machines of this VirtualMachinesResponse.
        virtual machines

        :return: The virtual_machines of this VirtualMachinesResponse.
        :rtype: list[VmTypeJson]
        """
        return self._virtual_machines

    @virtual_machines.setter
    def virtual_machines(self, virtual_machines):
        """
        Sets the virtual_machines of this VirtualMachinesResponse.
        virtual machines

        :param virtual_machines: The virtual_machines of this VirtualMachinesResponse.
        :type: list[VmTypeJson]
        """

        self._virtual_machines = virtual_machines

    @property
    def default_virtual_machine(self):
        """
        Gets the default_virtual_machine of this VirtualMachinesResponse.
        default virtual machines

        :return: The default_virtual_machine of this VirtualMachinesResponse.
        :rtype: VmTypeJson
        """
        return self._default_virtual_machine

    @default_virtual_machine.setter
    def default_virtual_machine(self, default_virtual_machine):
        """
        Sets the default_virtual_machine of this VirtualMachinesResponse.
        default virtual machines

        :param default_virtual_machine: The default_virtual_machine of this VirtualMachinesResponse.
        :type: VmTypeJson
        """

        self._default_virtual_machine = default_virtual_machine

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, VirtualMachinesResponse):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
